<?php
namespace Tests\Unit\App\Http\Controllers\Api;

use App\Http\Controllers\Api\StorageController;
use Illuminate\Http\Request;
use Illuminate\Contracts\Filesystem\Filesystem;
use Tests\TestCase;

/**
 * Generated by PHPUnit_SkeletonGenerator on 2015-11-11 at 17:40:07.
 */
class StorageControllerTest extends TestCase
{
    /**
     * Mock \Illuminate\Contracts\Filesystem\Filesystem
     *
     * @var \PHPUnit_Framework_MockObject_MockObject
     */
    protected $fileSystemMock;



    /**
     * Sets up the fixture, for example, opens a network connection.
     * This method is called before a test is executed.
     */
    public function setUp()
    {
        parent::setUp();

        $this->fileSystemMock = $this
            ->getMockBuilder(Filesystem::class)
            ->getMock();
    }


    /**
     * Storage Provider fo tests
     *
     * @return array
     */
    public function storageProvider()
    {
        return [
            ['a.txt', 'body', 'POST'],
            ['b.txt', 'body', 'PUT']
        ];
    }
    /**
     * @covers App\Http\Controllers\Api\StorageController::store
     * @dataProvider storageProvider
     */
    public function testStore($file, $body, $method)
    {
        $this->fileSystemMock
            ->method('put')
            ->willReturn(true);

        $this->fileSystemMock
            ->method('exists')
            ->willReturn(true);

        $request = new Request([], ['body' => $body]);
        $request->setMethod($method);

        $controller = new StorageController($this->fileSystemMock);

        $this->assertEquals(
            [
                'saved' => true
            ],
            $controller->store($request, $file)
        );
    }

    /**
     * @covers App\Http\Controllers\Api\StorageController::show
     * @dataProvider storageProvider
     */
    public function testShow($file)
    {
        $this->fileSystemMock
            ->method('get')
            ->willReturn('body');

        $this->fileSystemMock
            ->method('exists')
            ->willReturn(true);

        $controller = new StorageController($this->fileSystemMock);

        $this->assertEquals(
            [
                'body' => 'body'
            ],
            $controller->show($file)
        );
    }

    /**
     * @covers App\Http\Controllers\Api\StorageController::destroy
     * @dataProvider storageProvider
     */
    public function testDestroy($file)
    {
        $this->fileSystemMock
            ->method('delete')
            ->willReturn(true);

        $this->fileSystemMock
            ->method('exists')
            ->willReturn(true);

        $controller = new StorageController($this->fileSystemMock);

        $this->assertEquals(
            [
                'deleted' => true
            ],
            $controller->destroy($file)
        );
    }


    /**
     * @covers App\Http\Controllers\Api\StorageController::show
     * @dataProvider storageProvider
     * @expectedException \Symfony\Component\HttpKernel\Exception\NotFoundHttpException
     */
    public function testNotFoundShow($file)
    {
        $controller = new StorageController($this->fileSystemMock);
        $controller->show($file);
    }

    /**
     * @covers App\Http\Controllers\Api\StorageController::destroy
     * @dataProvider storageProvider
     * @expectedException \Symfony\Component\HttpKernel\Exception\NotFoundHttpException
     */
    public function testNotFoundDestroy($file)
    {
        $controller = new StorageController($this->fileSystemMock);
        $controller->destroy($file);
    }

    /**
     * @covers App\Http\Controllers\Api\StorageController::store
     * @dataProvider storageProvider
     * @expectedException \Symfony\Component\HttpKernel\Exception\BadRequestHttpException
     */
    public function testBadRequestStore($file, $body, $method)
    {
        $request = new Request([], []);
        $request->setMethod($method);

        $controller = new StorageController($this->fileSystemMock);
        $controller->store($request, $file);

    }

}
